%**************************************************************************
%   "Testing for Multiple Bubbles" by Phillips, Shi and Yu (2011)
    
%   In this program, we calculate critical values for the generalized sup 
%   ADF statistic.
% *************************************************************************
 

clear all
close all
clc

format short
 
qe=[0.90;0.95;0.99];

tic;

m=5000;
T=1680;              % change your sample size here
swindow0=36;         % change your minimum window size here
r0=36/T;  
dim=T-swindow0+1;

%% %%%% DATA GENERATING PROCESS %%%%%%
SI=1;
randn('seed',SI);   
e=randn(T,m); 
a=T^(-1);
y=cumsum(e+a);


%% THE GENERALIZED SUP ADF TEST %%%%%%
r2=swindow0:1:T;
r2=r2';
rw=r2-swindow0+1;

gsadf=ones(m,1);
sadfs=zeros(m,dim); 
  
for j=1:1:m; 

 for r2=swindow0:1:T;
    dim0=r2-swindow0+1;
    rwadft=zeros(dim0,1);
    for r1=1:1:dim0; 
       rwadft(r1)= ADF_FL(y(r1:r2,j),0,1);  % two tail 5% significant level
    end;  
    sadfs(j,r2)=max(rwadft);
 end;
  
gsadf(j,1)=max(sadfs(j,:),[],2);

end;

toc;

quantile_gsadf=quantile(gsadf,qe);


dlmwrite('CV_BSADF1680_36.txt', quantile_gsadf,'-append', 'delimiter', '\t','precision', '%14.7f')

type CV_BSADF1680_36.txt
